
#include <stdarg.h>
#include <iostream.h>


template<int R, class T>
class Array {
  int shape [R] ;
  int size ;
  T* data ;
public :
  Array() {data = new T ; }
  Array(int n_0, ...) {
    va_list ap ;

    size      = n_0 ;
    shape [0] = n_0 ;
    
    va_start(ap, n_0) ;
    for (int d = 1; d < R ; d++) {
      int n_d = va_arg(ap, int) ;

      shape [d] = n_d ;
      size = n_d * size ;
    }
    va_end(ap) ;

    data = new T [size] ;
  }
  ~Array() {delete data ; }

  T& operator()() {return *data ; }
  T& operator()(int i_0, ...) {
    va_list ap ;

    int stride, offset ;

    stride = size / shape [0] ;
    offset = i_0 * stride ;
    
    va_start(ap, n_0) ;
    for (int d = 1; d < R ; d++) {
      int i_d = va_arg(ap, int) ;

      stride /= shape [d] ;
      offset += i_d * stride ;
    }
    va_end(ap) ;

    return data [offset] ;
  }
} ;

main () {
  Array<3, float> a(5, 7, 11) ;
  Array<1, int> b(23) ;
  
  a(3, 2, 1) = 53.1 ;
  a(3, 2, 2) = 75.6 ;
  a(3, 3, 1) = 81.7 ;
  cout << a(3, 2, 1) << "\n" ;
  cout << a(3, 2, 2) << "\n" ;
  cout << a(3, 3, 1) << "\n" ;

  b(23) = a(3, 2, 1) ;
  cout << b(23) << "\n" ;
}

